package cn.ikamobile.trainfinder.statistics;

import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.After;
import org.aspectj.lang.reflect.MethodSignature;

import android.os.Bundle;
import android.view.View;

public aspect UmengStatisticAspect {

    // @AfterReturning(pointcut =
    // "execution(@cn.ikamobile.trainfinder.statistics.StatisticsClickEvent * *(..)) && args(view)")
    // public void weaveClickEventJoinPoint(View view, ProceedingJoinPoint joinPoint) {
    // MethodSignature methodSignature = (MethodSignature) joinPoint.getSignature();
    // String className = methodSignature.getDeclaringType().getSimpleName();
    //
    // UmengOnClickEventHandler clickEventHandler = new UmengOnClickEventHandler();
    // clickEventHandler.addStatisticsHandle("StatisticsClickEvent", className,
    // view.getResources().getResourceName(view.getId()));
    // }

    // @AfterReturning(pointcut = "execution(* *.onClick(View)) && args(view)")
    @After("execution(* *.onClick(View)) && args(view)")
    public void weaveOnClickEventJoinPoint(View view, ProceedingJoinPoint joinPoint) {
        MethodSignature methodSignature = (MethodSignature) joinPoint.getSignature();
        String className = getClassName(methodSignature.getDeclaringType().getName());

        UmengOnClickEventHandler clickEventHandler = new UmengOnClickEventHandler();
        clickEventHandler.addStatisticsHandle("onClick_event", className, view);
    }

    // @AfterReturning(pointcut = "execution(* *.onCreate(Bundle)) && args(savedInstanceState)")
    @After("execution(* *.onCreate(Bundle)) && args(savedInstanceState)")
    public void weaveOnCreateEventJoinPoint(Bundle savedInstanceState, ProceedingJoinPoint joinPoint) {
        MethodSignature methodSignature = (MethodSignature) joinPoint.getSignature();
        String className = getClassName(methodSignature.getDeclaringType().getName());

        UmengOnCreateEventHandler clickEventHandler = new UmengOnCreateEventHandler();
        clickEventHandler.addStatisticsHandle("onCreate_event", className, null);
    }

    // @AfterReturning(pointcut = "execution(* *.onResume())")
    @After("execution(* *.onResume())")
    public void weaveOnResumeEventJoinPoint(ProceedingJoinPoint joinPoint) {
        MethodSignature methodSignature = (MethodSignature) joinPoint.getSignature();
        String className = getClassName(methodSignature.getDeclaringType().getName());

        UmengOnResumeEventHandler clickEventHandler = new UmengOnResumeEventHandler();
        clickEventHandler.addStatisticsHandle("onResume_event", className, null);
    }

    private String getClassName(String name) {
        if (name.contains("$")) {
            int index = name.indexOf("$");
            return name.substring(0, index);
        } else {
            return name;
        }
    }
}
